-- Name: EAS_AddMoneyEvent
-- Author: Chissel

EAS_AddMoneyEvent = {}

local EAS_AddMoneyEvent_mt = Class(EAS_AddMoneyEvent, Event)
InitEventClass(EAS_AddMoneyEvent, "EAS_AddMoneyEvent")

function EAS_AddMoneyEvent.emptyNew()
    local self = Event.new(EAS_AddMoneyEvent_mt)

    return self
end

function EAS_AddMoneyEvent.new(amount, farmId)
    local self = EAS_AddMoneyEvent.emptyNew()

    self.amount = amount
    self.farmId = farmId

    return self
end

function EAS_AddMoneyEvent:readStream(streamId, connection)
    self.amount = streamReadInt32(streamId)
    self.farmId = streamReadInt32(streamId, 2)

    self:run(connection)
end

function EAS_AddMoneyEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, self.amount)
    streamWriteInt32(streamId, self.farmId, 2)
end

function EAS_AddMoneyEvent:run(connection)
    if not connection:getIsServer() then
        local amount = self.amount
        local farmId = self.farmId

        g_currentMission:addMoneyChange(amount, farmId, MoneyType.SOLD_ANIMALS, true)
        g_easUtils:logText("Event add "..amount.." money to farm with farmId: "..farmId)
        local farm = g_farmManager:getFarmById(farmId)
        farm:changeBalance(amount, MoneyType.SOLD_ANIMALS)
    else
        g_easUtils:logText("Error: EAS_AddMoneyEvent is a server only event!")
    end
end
